SystemOrganization addCategory: #'QwaqDemo-Client-ScriptEditor'!

CTreeItem subclass: #CDemoFrameTreeItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QwaqDemo-Client-ScriptEditor'!

!CDemoFrameTreeItem commentStamp: '<historical>' prior: 0!
A tree item representing arbitrary Croquet frames.!

CDemoFrameTreeItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CDemoFrameTreeItem class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!CDemoFrameTreeItem methodsFor: 'accessing' stamp: 'bgf 11/10/2009 22:24'!
getChildren
	
	value isValidFarRef ifTrue: [
		^(((value get: #frameChildren) ifNil:[^#()]) get: #asArray) collect:[:each| self class on: each].
	].
	^ #()! !

!CDemoFrameTreeItem methodsFor: 'accessing' stamp: 'ar 2/16/2006 13:18'!
getIcon
	"Retrieve the icon for this entry"
"@@@@ LATER @@@@"
	^nil! !

!CDemoFrameTreeItem methodsFor: 'accessing' stamp: 'bgf 12/16/2008 10:50'!
getLabel
	value isValidFarRef ifFalse: [ ^ 'Unknown' ].
	^(value get: #objectName), ' (', (value get: #class) name, ')'! !

!CDemoFrameTreeItem methodsFor: 'accessing' stamp: 'bgf 12/16/2008 10:49'!
hasChildren
	value isValidFarRef ifFalse: [ ^ false ].

	^(((value get: #frameChildren) ifNil:[^false]) get: #size) > 0! !

!CDemoFrameTreeItem methodsFor: 'events' stamp: 'ar 2/24/2006 16:59'!
onNameChanged
	<on: nameChanged in: value>
	self flag: #fixMe. "should update the name properly"! !

!CDemoFrameTreeItem methodsFor: 'events' stamp: 'ar 2/16/2006 22:22'!
onStructureChanged
	<on: structureChanged in: value>
	self children: self getChildren.! !

CPlayer subclass: #CDemoScriptEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QwaqDemo-Client-ScriptEditor'!

CDemoScriptEditor defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="space" toSet="space:" changeEvent="spaceChanged">space</field>
	<field toGet="objectsTree" toSet="objectsTree:" changeEvent="objectsTreeChanged">objectsTree</field>
	<field toGet="codePane" toSet="codePane:" changeEvent="codePaneChanged">codePane</field>
	<field toGet="scriptContext" toSet="scriptContext:" changeEvent="scriptContextChanged">scriptContext</field>
</fields>'!

!CDemoScriptEditor class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!CDemoScriptEditor class methodsFor: 'instance creation' stamp: 'ar 2/24/2006 17:59'!
openIn: container space: aSpace
	| wnd editor |
	editor := self new.
	editor space: aSpace.

	wnd := CWindow new.
	wnd extent: 400@200.
	wnd contentPane: editor.
	wnd dropShadowEnabled: false.
	wnd label: 'Script Editor'.
	wnd openIn: container.
	wnd decorate: wnd elements color: CWidgetLibrary default windowColor.
	^wnd! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/17/2006 12:42'!
codePane
	"Answer the codePane of the receiver"
	<bewareOf: #codePaneChanged>
	^self propertyValueAt: #codePane! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/17/2006 12:42'!
codePane: aValue
	"Modify the receiver's codePane"
	^self propertyValueAt: #codePane put: aValue with: #codePaneChanged! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/17/2006 12:43'!
contents
	^codePane contents! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/17/2006 12:43'!
contents: newContents
	codePane contents: newContents! !

!CDemoScriptEditor methodsFor: 'tree menu' stamp: 'ar 2/24/2006 16:05'!
destroySelected
	| obj objName |
	obj := objectsTree selection ifNil:[^Smalltalk beep].
	objName := obj get: #objectName.
	(self confirm: 'Destroy ', objName,'?') ifFalse:[^nil].
	obj future destroy.! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/17/2006 12:45'!
doItContext
	"Answer the context in which a text selection can be evaluated."
	^nil! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/20/2006 11:46'!
doItReceiver
	"Answer the object that should be informed of the result of evaluating a text selection."
	^objectsTree selection! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/22/2006 17:18'!
evaluateSelection: aPane
	| result |
	aPane editor selectLineIfEmpty.
	result := scriptContext future eval: aPane selection.
	result wait.
	^result value! !

!CDemoScriptEditor methodsFor: 'initialize' stamp: 'ar 2/20/2006 11:43'!
initialize
	super initialize.
	"Define our components"
	self define: #codePane as: CTextEditor new.
	self define: #objectsTree as: CTreeWidget new.! !

!CDemoScriptEditor methodsFor: 'tree menu' stamp: 'ar 2/24/2006 16:09'!
inspectSelected
	| obj |
	obj := objectsTree selection ifNil:[^Smalltalk beep].
	obj inspect.! !

!CDemoScriptEditor methodsFor: 'initialize' stamp: 'ar 2/17/2006 12:45'!
newCodePaneMenu: aPane
	| menu item |
	menu := CMenu new.
	menu label: nil.
		item := menu add: 'Find' target: aPane action: #findText.
		item icon: MenuIcons findIcon.
		item := menu add: 'Find Next' target: aPane action: #findNext.
		item icon: MenuIcons findIcon.
		item := menu add: 'Find and Replace' target: aPane action: #replace.
		item icon: MenuIcons findIcon.
	menu addSeparator.
		item := menu add: 'Undo' target: aPane action: #undo.
		item icon: MenuIcons undoIcon.
		item := menu add: 'Redo' target: aPane action: #undo.
		item icon: MenuIcons redoIcon.
	menu addSeparator.
		item := menu add: 'Copy' target: aPane action: #copySelection.
		item icon: MenuIcons copyIcon.
		item := menu add: 'Cut' target: aPane action: #cutSelection.
		item icon: MenuIcons cutIcon.
		item := menu add: 'Paste' target: aPane action: #pasteSelection.
		item icon: MenuIcons pasteIcon.
	menu addSeparator.
		item := menu add: 'Evaluate Selection' target: self 
				action: #signal:with: arguments: {#doIt. aPane}.
		item icon: MenuIcons doItIcon.
		item := menu add: 'Print Selection' target: self 
				action: #signal:with: arguments: {#printIt. aPane}.
		item icon: MenuIcons printIcon.
		item := menu add: 'Inspect Selection' target: self 
				action: #signal:with: arguments: {#inspectIt. aPane}.
		item icon: MenuIcons inspectIcon.
		item := menu add: 'Explore Selection' target: self 
				action: #signal:with: arguments: {#exploreIt. aPane}.
		item icon: MenuIcons inspectIcon.
		item := menu add: 'Debug Selection' target: self
				action: #signal:with: arguments: {#debugIt. aPane}.
		item icon: MenuIcons doItIcon.
	menu addSeparator.
		item := menu add: 'Accept' target: aPane action: #save.
		item icon: MenuIcons okIcon.
		item := menu add: 'Cancel' target: aPane action: #revert.
		item icon: MenuIcons cancelIcon.
	^menu! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/17/2006 12:46'!
notify: aString at: location in: source

	codePane selectionStart: location.
	codePane selectionStop: location.
	codePane paste: aString select: true.
! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/20/2006 11:42'!
objectsTree
	"Answer the objectsTree of the receiver"
	<bewareOf: #objectsTreeChanged>
	^self propertyValueAt: #objectsTree! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/20/2006 11:42'!
objectsTree: aValue
	"Modify the receiver's objectsTree"
	^self propertyValueAt: #objectsTree put: aValue with: #objectsTreeChanged! !

!CDemoScriptEditor methodsFor: 'tree menu' stamp: 'ar 2/24/2006 16:11'!
objectsTreeMenu
	| treeMenu |
	treeMenu := CMenu new.
	treeMenu add: 'Rename' target: self action: #renameSelected.
	treeMenu add: 'Inspect' target: self action: #inspectSelected.
	treeMenu addSeparator.
	treeMenu add: 'Destroy' target: self action: #destroySelected.
	^treeMenu! !

!CDemoScriptEditor methodsFor: 'validation' stamp: 'ar 2/17/2006 12:47'!
okToChange
	"See if there is unaccepted input"
	codePane modified ifFalse:[^true].
	(self confirm: 'Changes have not been saved.
Is it OK to cancel those changes?') ifFalse:[^false].
	codePane modified: false.
	^true! !

!CDemoScriptEditor methodsFor: 'validation' stamp: 'ar 2/17/2006 12:47'!
okToChangeList: aList from: prevValue
	"This is a slightly modified version of okToChange so that the user is not presented with weird changes in the selection. It silently sets back the list selection to its previous value until the user has decided what to do."
	| nextValue |
	nextValue := aList selection.
	nextValue = prevValue ifTrue:[^false]. "No need to change it"
	aList selection: prevValue.
	self okToChange ifFalse:[^false].
	aList selection: nextValue.
	^true! !

!CDemoScriptEditor methodsFor: 'events' stamp: 'ar 2/24/2006 17:34'!
onAcceptCodePane
	"Update the class list when the system category list's cursor changes"
	<on: save in: codePane> 
	scriptContext future workspace: codePane contents.! !

!CDemoScriptEditor methodsFor: 'events' stamp: 'ar 2/17/2006 12:47'!
onCodePaneKeyDown: evt
	"Update the message category list when the class list's cursor changes"
	<on: keyDown in: codePane>
	self onCodePaneKeyDown: evt in: codePane.! !

!CDemoScriptEditor methodsFor: 'events' stamp: 'ar 2/17/2006 12:47'!
onCodePaneKeyDown: evt in: aPane
	"Resignal code pane events"
	| action |
	action := CPlatform current standardCodingKeys lookupEvent: evt.
	action ifNotNil:[self signal: action with: aPane].! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/17/2006 12:46'!
onDebugIt: aPane
	"Treat the current text selection as an expression; debug it."
	<on: debugIt>
	Smalltalk beep.! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/17/2006 12:46'!
onDoIt: aPane
	"Set the context to include pool vars of the model.  Then evaluate."
	<on: doIt>
	^ self evaluateSelection: aPane! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/17/2006 12:46'!
onInspectIt: aPane
	"Treat the current text selection as an expression; evaluate it.
	Open an inspector on the result of the expression."
	| result |
	<on: inspectIt>
	result := self evaluateSelection: aPane.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
		ifTrue: [^aPane flash].
	result inspect! !

!CDemoScriptEditor methodsFor: 'events' stamp: 'ar 2/17/2006 12:47'!
onPasteIfFalse: aPane
	<on: pasteIfFalse>
	aPane paste: 'ifFalse:'! !

!CDemoScriptEditor methodsFor: 'events' stamp: 'ar 2/17/2006 12:48'!
onPasteIfTrue: aPane
	<on: pasteIfTrue>
	aPane paste: 'ifTrue:'! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/17/2006 12:46'!
onPrintIt: aPane
	"Treat the current text selection as an expression; evaluate it. Insert the 
	description of the result of evaluation after the selection and then make 
	this description the new text selection."
	| result |
	<on: printIt>
	result := self evaluateSelection: aPane.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
		ifTrue: [^aPane flash].
	aPane selectionStart: aPane selectionStop.
	aPane paste: ' ', result printString select: true.
! !

!CDemoScriptEditor methodsFor: 'events' stamp: 'ar 2/17/2006 12:47'!
onRevert
	<on: revert in: codePane>
	self onUpdateCodePane.! !

!CDemoScriptEditor methodsFor: 'events' stamp: 'ar 2/24/2006 17:33'!
onSpaceChanged
	| ctx ws |
	<on: spaceChanged>
	"Update objects tree"
	space ifNil:[^objectsTree rootNodes: #()].
	objectsTree rootNode: (CDemoFrameTreeItem on: space).
	"Update script context"
	(space get: #scriptContext) ifNil:[
		ctx := space island future new: TScriptContext.
		ctx future root: space.
		ctx future bind: #space to: space.
		space future scriptContext: ctx.
	].
	scriptContext := space future scriptContext.
	ws := scriptContext future workspace.
	ws whenResolved:[codePane contents: ws value].! !

!CDemoScriptEditor methodsFor: 'events' stamp: 'ar 2/17/2006 12:47'!
onUpdateCodePane
	<on: updateCodePane>
	Smalltalk beep.! !

!CDemoScriptEditor methodsFor: 'tree menu' stamp: 'ar 2/24/2006 16:16'!
renameSelected
	| obj objName oldName newName |
	obj := objectsTree selection ifNil:[^Smalltalk beep].
	oldName := obj get: #objectName.
	newName := UIManager default 
		request: 'Please enter new name'
		initialAnswer: objName.
	newName ifNil:[^nil].
	oldName = newName ifTrue:[^nil].
	scriptContext future rename: obj to: newName.
! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/22/2006 17:16'!
scriptContext
	"Answer the scriptContext of the receiver"
	<bewareOf: #scriptContextChanged>
	^self propertyValueAt: #scriptContext! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/22/2006 17:16'!
scriptContext: aValue
	"Modify the receiver's scriptContext"
	^self propertyValueAt: #scriptContext put: aValue with: #scriptContextChanged! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/17/2006 12:46'!
selectFrom: start to: stop
	codePane selectFrom: start to: stop! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/17/2006 12:48'!
selectedClass
	"Answer the currently selected class (not just its name)"
	^nil! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/17/2006 12:48'!
selectedClassName
	"Answer the name of the currently selected"
	^(self selectedClass ifNil:[^nil]) name! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/17/2006 12:48'!
selectedSelector
	"Try to make a selector out of the current text selection"
	^codePane selection string findSelector! !

!CDemoScriptEditor methodsFor: 'evaluating' stamp: 'ar 2/17/2006 12:46'!
selectionInterval
	^codePane selectionStart to: codePane selectionStop! !

!CDemoScriptEditor methodsFor: 'initialize' stamp: 'ar 2/24/2006 17:57'!
setupCostume
	"Create the default costume"
	super setupCostume.
	self extent: 400@265.
	self layout: CProportionalLayout new.

	objectsTree color: Color transparent.
	objectsTree layoutFrame: (0.0@0 corner: 0.33@1).
	objectsTree hResizing: #spaceFill; vResizing: #spaceFill.
	objectsTree hScrollable: false; vScrollable: true.
	objectsTree menu: self objectsTreeMenu.
	self add: objectsTree.

	codePane color: Color transparent.
	codePane layoutFrame: (0.33@0 corner: 1@1).
	codePane hResizing: #spaceFill; vResizing: #spaceFill.
	codePane textWrap: true.
	codePane hScrollable: false; vScrollable: true.
	codePane menu: (self newCodePaneMenu: codePane).
	self add: codePane.
! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/22/2006 02:04'!
space
	"Answer the space of the receiver"
	<bewareOf: #spaceChanged>
	^self propertyValueAt: #space! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/22/2006 02:04'!
space: aValue
	"Modify the receiver's space"
	^self propertyValueAt: #space put: aValue with: #spaceChanged! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'ar 2/17/2006 12:48'!
textHolder
	^codePane textHolder! !

!CDemoScriptEditor methodsFor: 'accessing' stamp: 'bgf 12/16/2006 18:08'!
visible: aBool
	"Extended to add a signal when changed; the Tweak players don't signal this"
	
	(self visible ~= aBool) ifTrue: [
		super visible: aBool.
		self signal: #visibleChanged with: aBool
	].
	! !

Object subclass: #TScriptContext
	instanceVariableNames: 'root bindings workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QwaqDemo-Client-ScriptEditor'!

!TScriptContext class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!TScriptContext methodsFor: 'bindings' stamp: 'ar 2/22/2006 17:23'!
bind: varName to: newValue
	"Bind name to value"
	^(self bindingOf: varName) value: newValue
! !

!TScriptContext methodsFor: 'bindings' stamp: 'ar 2/22/2006 19:09'!
bindingOf: varName
	| var |
	var := varName asSymbol.
	bindings at: var ifAbsentPut:[self lookup: varName].
	^bindings associationAt: var! !

!TScriptContext methodsFor: 'evaluating' stamp: 'eem 5/13/2008 15:50'!
eval: code
	"Evaluate the given code in the receiver."
	| result var |
	result := [
		[CCompiler new 
			evaluate: code readStream
			in: nil
			to: nil
			notifying: nil
			ifFail: [^nil]] on: UndeclaredVariableReference do:[:udv|
				var := udv varName asSymbol.
				udv resume: (udv parser encoder global: (self bindingOf: var) name: var).
			].
	] on: Error do:[:ex| ex return: nil].
	^result! !

!TScriptContext methodsFor: 'initialize' stamp: 'ar 2/24/2006 17:35'!
initialize
	super initialize.
	bindings := Dictionary new.
	workspace := ''.! !

!TScriptContext methodsFor: 'bindings' stamp: 'ar 2/22/2006 19:28'!
lookup: varName
	"Answer the binding for the given variable (if any)"
	(root frameChildren ifNil:[^nil]) do:[:each|
		each objectName = varName ifTrue:[^each].
	].
	^nil! !

!TScriptContext methodsFor: 'evaluating' stamp: 'ar 2/24/2006 16:35'!
rename: obj to: proposedName
	"Rename the given object"
	| parent oldNames newName pair |
	newName := proposedName.
	parent := obj parent.
	parent ifNotNil:[
		oldNames := Set new.
		(parent frameChildren ifNil:[#()]) do:[:each|
			oldNames add: each objectName.
		].
		[oldNames includes: newName] whileTrue:[
			pair := newName stemAndNumericSuffix.
			newName := pair first, (pair last+1 max: 2) printString.
		].
	].
	obj objectName: newName.
! !

!TScriptContext methodsFor: 'accessing' stamp: 'ar 2/22/2006 19:04'!
root
	^root! !

!TScriptContext methodsFor: 'accessing' stamp: 'ar 2/22/2006 19:04'!
root: anObject
	root := anObject.! !

!TScriptContext methodsFor: 'accessing' stamp: 'ar 2/24/2006 17:35'!
workspace
	^workspace! !

!TScriptContext methodsFor: 'accessing' stamp: 'ar 2/24/2006 17:35'!
workspace: aStringOrText
	workspace := aStringOrText! !
